//*****************************************************************************
//*
//*
//*		ExcelDemoDlg.cpp : Implementierungsdatei
//*
//*
//*****************************************************************************
#include "StdAfx.h"
#include "ExcelDemo.h"
#include "ExcelDemoDlg.h"
#include "Excel.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char  THIS_FILE[] = __FILE__;
#endif

CExcel	sExcelDoc;


BEGIN_MESSAGE_MAP(CExcelDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CExcelDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELCHANGE(IDC_COMBO1, OnChangeWorksheet)
	ON_BN_CLICKED(IDC_BUTTON1, OnSetPath)
	ON_BN_CLICKED(IDC_BUTTON2, OnLoad)
	ON_BN_CLICKED(IDC_BUTTON3, OnSave)
	ON_BN_CLICKED(IDC_BUTTON4, OnSaveAs)
	ON_BN_CLICKED(IDC_BUTTON5, OnCreate)
	ON_BN_CLICKED(IDC_BUTTON6, OnNewWorksheet)
	ON_BN_CLICKED(IDC_BUTTON7, OnSaveData)
	ON_BN_CLICKED(IDC_CHECK1, OnChangeMode)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


inline const char *IS_STR_OK(const char *pSting){if(pSting)return pSting;return "";}

//*****************************************************************************
//*
//*		CExcelDemoDlg Dialogfeld
//*
//*****************************************************************************
CExcelDemoDlg::CExcelDemoDlg(CWnd *pParent) : CDialog(CExcelDemoDlg::IDD,pParent)
{
char	cText[256];
int		iLen;

	//{{AFX_DATA_INIT(CExcelDemoDlg)
	m_sDataA1 = _T("");
	m_sDataA3 = _T("");
	m_sDataC3 = _T("");
	m_sDataB3 = _T("");
	m_sDataB1 = _T("");
	m_sDataC1 = _T("");
	m_sDataA2 = _T("");
	m_sDataB2 = _T("");
	m_sDataC2 = _T("");
	m_sPath = _T("");
	m_iWorksheet = -1;
	m_bFomular = FALSE;
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	iLen=GetModuleFileName(0,cText,sizeof(cText));
	for(;iLen>0;iLen--)
		{
		if(cText[iLen]=='\\')break;
		}

	cText[iLen]=0;
	m_sPath = cText;
	#ifdef _DEBUG
	m_sPath += _T("\\..\\Test.xls");
	#else 	
	m_sPath += _T("\\Test.xls");
	#endif 	


}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CExcelDemoDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExcelDemoDlg)
	DDX_Control(pDX, IDC_COMBO1, m_cWorksheets);
	DDX_Text(pDX, IDC_EDIT1, m_sDataA1);
	DDX_Text(pDX, IDC_EDIT7, m_sDataA3);
	DDX_Text(pDX, IDC_EDIT9, m_sDataC3);
	DDX_Text(pDX, IDC_EDIT8, m_sDataB3);
	DDX_Text(pDX, IDC_EDIT2, m_sDataB1);
	DDX_Text(pDX, IDC_EDIT3, m_sDataC1);
	DDX_Text(pDX, IDC_EDIT4, m_sDataA2);
	DDX_Text(pDX, IDC_EDIT5, m_sDataB2);
	DDX_Text(pDX, IDC_EDIT6, m_sDataC2);
	DDX_Text(pDX, IDC_EDIT10, m_sPath);
	DDX_CBIndex(pDX, IDC_COMBO1, m_iWorksheet);
	DDX_Check(pDX, IDC_CHECK1, m_bFomular);
	//}}AFX_DATA_MAP
}



//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CExcelDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	
	if(pSysMenu != NULL)
		{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		
		if (!strAboutMenu.IsEmpty())
			{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
			}
		}

	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

	sExcelDoc.Open(m_sPath);
	GetExecelData();
	
	
return TRUE;
}


//*****************************************************************************
//*
//*		OnSysCommand
//*
//*****************************************************************************
void CExcelDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
		{
		CDialog	dlgAbout(IDD_ABOUTBOX,this);
		dlgAbout.DoModal();
		}
	else{
		CDialog::OnSysCommand(nID, lParam);
		}
}


//*****************************************************************************
//*
//*		OnPaint
//*
//*****************************************************************************
// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.
void CExcelDemoDlg::OnPaint() 
{
	if(IsIconic())
		{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
		}
	else{
		CDialog::OnPaint();
		}
}


//*****************************************************************************
//*
//*		OnQueryDragIcon
//*
//*****************************************************************************
HCURSOR CExcelDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CExcelDemoDlg::OnOK() 
{
	sExcelDoc.Release();	
	CDialog::OnOK();
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CExcelDemoDlg::OnCancel() 
{
	sExcelDoc.Release();	
	CDialog::OnCancel();
}

//*****************************************************************************
//*
//*		OnChangeWorksheet
//*
//*****************************************************************************
void CExcelDemoDlg::OnChangeWorksheet() 
{
	GetExecelData();	
}


//*****************************************************************************
//*
//*		OnSetPath
//*
//*****************************************************************************
void CExcelDemoDlg::OnSetPath() 
{
	UpdateData();

	CFileDialog	sDlg(FALSE,"*.xls",m_sPath,OFN_EXPLORER|OFN_ENABLESIZING|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY,"EXCEL Dokument (*.xls)|*.xls|Alle Dateien (*.*)|*.*|");

	if(sDlg.DoModal()!=IDOK)return;
	m_sPath=sDlg.GetPathName();

	UpdateData(FALSE);

}

//*****************************************************************************
//*
//*		OnLoad
//*
//*****************************************************************************
void CExcelDemoDlg::OnLoad() 
{
	UpdateData();

	if(!sExcelDoc.Open(m_sPath,0))
		{
		MessageBox("Fehler beim ffnen !");
		}	
	
	GetExecelData();	
}

//*****************************************************************************
//*
//*		OnSave
//*
//*****************************************************************************
void CExcelDemoDlg::OnSave() 
{

	if(!sExcelDoc.Save())
		{
		MessageBox("Fehler beim Speichern !");
		}	

}


//*****************************************************************************
//*
//*		OnSaveAs
//*
//*****************************************************************************
void CExcelDemoDlg::OnSaveAs() 
{
	UpdateData();

	if(!sExcelDoc.SaveAs(m_sPath))
		{
		MessageBox("Fehler beim Speichern !");
		}	
}


//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
void CExcelDemoDlg::OnCreate() 
{
	if(!sExcelDoc.AddWorksheet())
		{
		MessageBox("Fehler beim Erzeugen eines neuen Dokumentes !");
		}	

	 GetExecelData();
	
}


//*****************************************************************************
//*
//*		OnNewWorksheet
//*
//*****************************************************************************
void CExcelDemoDlg::OnNewWorksheet() 
{
CString	sName;

	if(!sExcelDoc.AddWorksheet())
		{
		MessageBox("Fehler beim Einfgen eines neuen Blattes !");
		}	

	sName=sExcelDoc.GetWorksheetName();
	GetExecelData();
	if(sName!="")
		{
		m_cWorksheets.SelectString(-1,sName);
		}

}



//*****************************************************************************
//*
//*		OnChangeMode
//*
//*****************************************************************************
void CExcelDemoDlg::OnChangeMode() 
{

	UpdateData();
	GetExecelData();
	
}

//*****************************************************************************
//*
//*		OnSaveData
//*
//*****************************************************************************
void CExcelDemoDlg::OnSaveData() 
{

	UpdateData();

	if(m_bFomular)
		{
		sExcelDoc.SetFormula(0,0,m_sDataA1);
		sExcelDoc.SetFormula(0,1,m_sDataB1);
		sExcelDoc.SetFormula(0,2,m_sDataC1);
		sExcelDoc.SetFormula(1,0,m_sDataA2);
		sExcelDoc.SetFormula(1,1,m_sDataB2);
		sExcelDoc.SetFormula(1,2,m_sDataC2);
		sExcelDoc.SetFormula(2,0,m_sDataA3);
		sExcelDoc.SetFormula(2,1,m_sDataB3);
		sExcelDoc.SetFormula(2,2,m_sDataC3);
		}
	else{
		sExcelDoc.SetValue(0,0,m_sDataA1);
		sExcelDoc.SetValue(0,1,m_sDataB1);
		sExcelDoc.SetValue(0,2,m_sDataC1);
		sExcelDoc.SetValue(1,0,m_sDataA2);
		sExcelDoc.SetValue(1,1,m_sDataB2);
		sExcelDoc.SetValue(1,2,m_sDataC2);
		sExcelDoc.SetValue(2,0,m_sDataA3);
		sExcelDoc.SetValue(2,1,m_sDataB3);
		sExcelDoc.SetValue(2,2,m_sDataC3);
		}
	
}



//*****************************************************************************
//*
//*		GetExecelData
//*
//*****************************************************************************
void CExcelDemoDlg::GetExecelData()
{
CString	sSheet;
CString	sName;
int		iNum;
int		iSel;
int		i;


	iSel = m_cWorksheets.GetCurSel();
	if(iSel>=0)m_cWorksheets.GetLBText(iSel,sSheet);
	iNum = sExcelDoc.GetWorksheetCount();

	if(iNum==0)
		{
		m_sDataA1="";
		m_sDataB1="";
		m_sDataC1="";
		m_sDataA2="";
		m_sDataB2="";
		m_sDataC2="";
		m_sDataA3="";
		m_sDataB3="";
		m_sDataC3="";

		GetDlgItem(IDC_EDIT1)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT2)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT3)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT4)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT5)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT6)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT7)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT8)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT9)->EnableWindow(FALSE);
		m_cWorksheets.EnableWindow(FALSE);
		m_cWorksheets.ResetContent();

		UpdateData(FALSE);
		return;
		}


	m_cWorksheets.ResetContent();

	for(i=0,iSel=-1;i<iNum;i++)
		{
		if(!sExcelDoc.SelectWorksheet(i))break;
			
		sName = sExcelDoc.GetWorksheetName();
		m_cWorksheets.InsertString(i,sName);

		if(sName==sSheet)iSel=i;
		}

	if(iSel<0)iSel=0;

	m_iWorksheet=iSel;
	sExcelDoc.SelectWorksheet(iSel);
	m_cWorksheets.SetCurSel(iSel);			
	
	if(m_bFomular)
		{
		m_sDataA1=IS_STR_OK(sExcelDoc.GetFormula(0,0));
		m_sDataB1=IS_STR_OK(sExcelDoc.GetFormula(0,1));
		m_sDataC1=IS_STR_OK(sExcelDoc.GetFormula(0,2));
		m_sDataA2=IS_STR_OK(sExcelDoc.GetFormula(1,0));
		m_sDataB2=IS_STR_OK(sExcelDoc.GetFormula(1,1));
		m_sDataC2=IS_STR_OK(sExcelDoc.GetFormula(1,2));
		m_sDataA3=IS_STR_OK(sExcelDoc.GetFormula(2,0));
		m_sDataB3=IS_STR_OK(sExcelDoc.GetFormula(2,1));
		m_sDataC3=IS_STR_OK(sExcelDoc.GetFormula(2,2));
		}
	else{
		m_sDataA1=IS_STR_OK(sExcelDoc.GetValue(0,0));
		m_sDataB1=IS_STR_OK(sExcelDoc.GetValue(0,1));
		m_sDataC1=IS_STR_OK(sExcelDoc.GetValue(0,2));
		m_sDataA2=IS_STR_OK(sExcelDoc.GetValue(1,0));
		m_sDataB2=IS_STR_OK(sExcelDoc.GetValue(1,1));
		m_sDataC2=IS_STR_OK(sExcelDoc.GetValue(1,2));
		m_sDataA3=IS_STR_OK(sExcelDoc.GetValue(2,0));
		m_sDataB3=IS_STR_OK(sExcelDoc.GetValue(2,1));
		m_sDataC3=IS_STR_OK(sExcelDoc.GetValue(2,2));
		}
	
	
	GetDlgItem(IDC_EDIT1)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT2)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT3)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT4)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT5)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT6)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT7)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT8)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT9)->EnableWindow(TRUE);
	m_cWorksheets.EnableWindow(TRUE);

	UpdateData(FALSE);


}


